#41 mail sent from localhost always deferred when dk-filter runs

v0.4.1
closed
5
2007-03-28
2006-10-03
gelgin
No

Oct 2 20:15:40 mail5 sendmail[10644]: k931Fdhh010644:
Milter add: header: X-Greylist: Sender IP whitelisted,
not delayed by milter-greylist-3.0a6
(mail5.internut.com [127.0.0.1]); Mon, 02 Oct 2006
20:15:40 -0500 (CDT)
Oct 2 20:15:40 mail5 dk-filter[8740]: k931Fdhh010644:
dk_getsig(): resource unavailable: Success
Oct 2 20:15:40 mail5 sendmail[10644]: k931Fdhh010644:
Milter: data, reject=451 4.3.2 Please try again later
Oct 2 20:15:40 mail5 sendmail[10644]: k931Fdhh010644:
to=<gelgin@yahoo.com>, delay=00:00:00, pri=30841,
stat=Please try again later

since i have a second milter running before dk not
sure if that is an issue. i know it seems like a
sendmail problem but it does go away when i stop dk-
filter, and i can't find 4.3.2's in my sendmail.cf
file.

Discussion

    • assigned_to: nobody --> sm-msk
     
  • Logged In: YES
    user_id=1048957

    Can you reproduce this problem reliably?

    The error message unfortunately doesn't reveal much, which
    is something I'll have to fix. However, dk_getsig()
    returning a "resource unavailable" error generally means
    either your system wasn't allowing any more memory
    allocations or there's corruption in the keys.

     
  • James Turnbull
    James Turnbull
    2006-11-28

    Logged In: YES
    user_id=1364759
    Originator: NO

    I am having a similar/same problems on Postfix 2.3.3 on Linux (Linux absinthe.lovedthanlost.net 2.6.18-1.2849.fc6 #1 SMP Fri Nov 10 12:34:46 EST 2006 x86_64 x86_64 x86_64 GNU/Linux). My logs are:

    Nov 28 17:01:16 absinthe dk-filter[7914]: Sendmail DomainKeys Filter v0.4.1 starting (args: -l -u smtpd -s /var/db/domainkeys/absinthe.key.pem -p inet:8893@localhost -S absinthe -d lovedthanlost.net)
    Nov 28 17:03:05 absinthe dk-filter[7914]: WARNING: sendmail symbol 'i' not available
    Nov 28 17:04:29 absinthe dk-filter[7914]: (unknown-jobid): dk_getsig(): resource unavailable: Cannot allocate memory
    Nov 28 17:04:29 absinthe postfix/cleanup[7951]: 8297829C0054: milter-reject: END-OF-MESSAGE from absinthe.lovedthanlost.net[127.0.0.1]: 4.7.1 Service unavailable - try again later; from=<root@lovedthanlost.net> to=<autorespond+dkim@dk.elandsys.com> proto=ESMTP helo=<absinthe.lovedthanlost.net>
    Nov 28 17:04:29 absinthe sendmail[7955]: kAS64TnI007955: to=autorespond+dkim@dk.elandsys.com, ctladdr=root (0/0), delay=00:00:00, xdelay=00:00:00, mailer=relay, pri=30069, relay=[127.0.0.1] [127.0.0.1], dsn=4.0.0, stat=Deferred: 451 4.7.1 Service unavailable - try again later

    Also - workaround for Postfix ('i' not available) no longer seems to work on dk-milter (or I stuffed something) - can this fix be rolled into mainline rather than having to be manually patched?

     
  • Logged In: YES
    user_id=1048957
    Originator: NO

    What are your command line options?

    Unfortunately libdk does have a few places where it reports a resource problem when it's not actually a resource problem. "resource unavailable" can be logged for any of these:

    - malloc() failed to allocate memory
    - base64 decoding of a key or signature failed*
    - creation of a temporary file failed
    - an OpenSSL function failed*

    It's probably one of the two things marked "*" in the above list. Both of them are usually key or signature corruption of some kind. You'd have to walk through it in gdb to figure out which it is, or give me a message and key that reproduces the problem so I can do so myself.

    The newest libdkim does a much better job of reporting what happened. I haven't had a chance yet to copy this code into libdk.

     
    • status: open --> pending
     
  • gelgin
    gelgin
    2007-03-13

    Logged In: YES
    user_id=1320859
    Originator: YES

    i decided to try this milter again. so i rebuilt and regenerated the keyes. if i
    DO NOT remove anything from the public key file outgoing mail from localhost works
    but incoming doesn't seem to.

    i am not sure if you were asking me what my arguments were so here is a log snip>

    Mar 12 15:05:28 mail5 dk-filter[5671]: Sendmail DomainKeys Filter v0.4.1 startin
    g (args: -h -l -p /var/dk-filter/dk-filter.sock -P /var/dk-filter/dk-filter.pid
    -d internut.com,exgig.com -D -s /var/dk-filter/internut.key.pem -S pub -u smmsp)
    Mar 12 15:07:12 mail5 dk-filter[5671]: l2CK6s8c005683: syntax error in signature
    data
    Mar 12 15:17:41 mail5 dk-filter[5671]: l2CKHfnS005824: syntax error in signature
    data
    Mar 12 15:21:32 mail5 dk-filter[5671]: l2CKLWjX005923: syntax error in signature
    data
    Mar 12 15:27:24 mail5 dk-filter[5671]: l2CKR7ai006017: syntax error in signature
    data
    Mar 12 15:27:27 mail5 dk-filter[5671]: l2CKR7sp006018: bad signature data
    Mar 12 15:28:04 mail5 dk-filter[5671]: l2CKS4rw006040: bad signature data
    Mar 12 15:35:12 mail5 dk-filter[5671]: l2CKYu7M006052: syntax error in signature
    data

     
  • gelgin
    gelgin
    2007-03-13

    • status: pending --> open
     
  • Logged In: YES
    user_id=1048957
    Originator: NO

    Those errors are reasonable if the messages arriving have syntax errors, which I see from time to time. If for example the From: header is unparseable (as in a lot of spam attacks), a syntax error can result. If a signed message goes through a mailing list server, its signature could be invalidated which produces the "bad signature data" error.

    Version 0.5.0 (coming soon) will provide more details in the logs.

    If you send a message to sa-test@sendmail.net, does the reply say your message was properly signed? And is the reply itself properly signed? (Look at the body of the reply to check the former, and the Authentication-Results: header for the latter.)

     
    • status: open --> pending
     
  • Logged In: YES
    user_id=1312539
    Originator: NO

    This Tracker item was closed automatically by the system. It was
    previously set to a Pending status, and the original submitter
    did not respond within 14 days (the time period specified by
    the administrator of this Tracker).

     
    • status: pending --> closed